# SoVRMLAudioClip Class Reference
[VRML97 classes, 3D sound support]

`#include <Inventor/VRMLnodes/SoVRMLAudioClip.h>`

Inheritance diagram for SoVRMLAudioClip:

List of all members.

## Detailed Description

The SoVRMLAudioClip class is used to load and store audio data.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      AudioClip {
        exposedField   SFString description      ""
        exposedField   SFBool   loop             FALSE
        exposedField   SFFloat  pitch            1.0        # (0, inf)
        exposedField   SFTime   startTime        0          # (-inf, inf)
        exposedField   SFTime   stopTime         0          # (-inf, inf)
        exposedField   MFString url              []
        eventOut       SFTime   duration_changed
        eventOut       SFBool   isActive
      }

An AudioClip node specifies audio data that can be referenced by Sound nodes. The description field specifies a textual description of the audio source. A browser is not required to display the description field but may choose to do so in addition to playing the sound. The url field specifies the URL from which the sound is loaded. Browsers shall support at least the wavefile format in uncompressed PCM format (see http://www.web3d.org/technicalinfo/specifications/vrml97/part1/bibliography.html#[WAV]). It is recommended that browsers also support the MIDI file type 1 sound format (see http://www.web3d.org/technicalinfo/specifications/vrml97/part1/references.html#[MIDI]); MIDI files are presumed to use the General MIDI patch set. Subclause 4.5, VRML and the World Wide Web (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.5>), contains details on the url field. The results are undefined when no URLs refer to supported data types.

The loop, startTime, and stopTime exposedFields and the isActive eventOut, and their effects on the AudioClip node, are discussed in detail in 4.6.9, Time-dependent nodes (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.9>). The "cycle" of an AudioClip is the length of time in seconds for one playing of the audio at the specified pitch. The pitch field specifies a multiplier for the rate at which sampled sound is played. Values for the pitch field shall be greater than zero. Changing the pitch field affects both the pitch and playback speed of a sound. A set_pitch event to an active AudioClip is ignored and no pitch_changed eventOut is generated. If pitch is set to 2.0, the sound shall be played one octave higher than normal and played twice as fast. For a sampled sound, the pitch field alters the sampling rate at which the sound is played. The proper implementation of pitch control for MIDI (or other note sequence sound clips) is to multiply the tempo of the playback by the pitch value and adjust the MIDI Coarse Tune and Fine Tune controls to achieve the proper pitch change. A duration_changed event is sent whenever there is a new value for the "normal" duration of the clip. Typically, this will only occur when the current url in use changes and the sound data has been loaded, indicating that the clip is playing a different sound source. The duration is the length of time in seconds for one cycle of the audio for a pitch set to 1.0. Changing the pitch field will not trigger a duration_changed event. A duration value of "-1" implies that the sound data has not yet loaded or the value is unavailable for some reason. A duration_changed event shall be generated if the AudioClip node is loaded when the VRML file is read or the AudioClip node is added to the scene graph. The isActive eventOut may be used by other nodes to determine if the clip is currently active. If an AudioClip is active, it shall be playing the sound corresponding to the sound time (i.e., in the sound's local time system with sample 0 at time 0):

      t = (now - startTime) modulo (duration / pitch)

## Public Types

typedef void * | open_func (const SbStringList &url, SoVRMLAudioClip *clip, void *userdataptr)
typedef size_t | read_func (void *datasource, void *buffer, int numframes, int &channels, SoVRMLAudioClip *clip, void *userdataptr)
typedef int | seek_func (void *datasource, long offset, int whence, SoVRMLAudioClip *clip, void *userdataptr)
typedef long | tell_func (void *datasource, SoVRMLAudioClip *clip, void *userdataptr)
typedef int | close_func (void *datasource, SoVRMLAudioClip *clip, void *userdataptr)

## Public Member Functions

| SoVRMLAudioClip (void)
int | getSampleRate ()
void * | open (const SbStringList &url)
size_t | read (void *datasource, void *buffer, int numframes, int &channels)
int | seek (void *datasource, long offset, int whence)
long | tell (void *datasource)
int | close (void *datasource)
void | setCallbacks (open_func *opencb, read_func *readcb, seek_func *seekcb, tell_func *tellcb, close_func *closecb, void *userdataptr)

## Static Public Member Functions

void | initClass (void)
void | setSubdirectories (const SbList< SbString > &subdirectories)
const SbStringList & | getSubdirectories ()
void | setDefaultPauseBetweenTracks (SbTime pause)
SbTime | getDefaultPauseBetweenTracks ()
void | setDefaultIntroPause (SbTime pause)
SbTime | getDefaultIntroPause ()
void | setDefaultSampleRate (int samplerate)
int | getDefaultSampleRate ()
void | setDefaultTimerInterval (SbTime interval)
SbTime | getDefaultTimerInterval ()

## Public Attributes

SoSFString | description
SoSFBool | loop
SoSFFloat | pitch
SoSFTime | startTime
SoSFTime | stopTime
SoMFString | url

## Protected Member Functions

virtual | ~SoVRMLAudioClip ()

## Protected Attributes

SoSFTime | duration_changed
SoSFBool | isActive

## Friends

class | SoVRMLAudioClipP

## Constructor & Destructor Documentation

SoVRMLAudioClip::SoVRMLAudioClip | ( | void |  | ) |

| Constructor.

SoVRMLAudioClip::~SoVRMLAudioClip | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLAudioClip::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void * SoVRMLAudioClip::open | ( | const SbStringList & | url | ) |

| Opens an audio source with the given url. Returns a handle to the datasource.

size_t SoVRMLAudioClip::read | ( | void * | datasource,
|  | void * | buffer,
|  | int | numframes,
|  | int & | channels
| ) |

| Reads numframes frames of audio with channels channels from datasource into buffer. Buffer must be allocated by the caller, and must be able to hold all the audio data (size = numframes * channels * sizeof(int16_t)). Returns 0 if an error occured, otherwise returns the number of frames actually read (should allways be equal to numframes).

int SoVRMLAudioClip::seek | ( | void * | datasource,
|  | long | offset,
|  | int | whence
| ) |

| Moves the "filepointer" in the datasource, returns -1L on error.

long SoVRMLAudioClip::tell | ( | void * | datasource | ) |

| Returns the current position of the "filepointer" in the datasource, or -1L on error.

int SoVRMLAudioClip::close | ( | void * | datasource | ) |

| Closes datasource.

void SoVRMLAudioClip::setCallbacks | ( | open_func * | opencb,
|  | read_func * | readcb,
|  | seek_func * | seekcb,
|  | tell_func * | tellcb,
|  | close_func * | closecb,
|  | void * | userdataptr
| ) |

| Sets callbacks for opening, reading, seeking, telling and closing an audio source. Specifying NULL for a function is OK, except for the read function. If a function set to NULL is later called, a default implementation doing nothing is called in it's place.

## Member Data Documentation

SoSFString SoVRMLAudioClip::description

| Description of the audio clip. Default value is an empty string.

SoSFBool SoVRMLAudioClip::loop

| Specifies whether sound should be looped. Is FALSE by default.

SoSFFloat SoVRMLAudioClip::pitch

| Specifies the pitch. The default value is 1.0. Alters the sampling rate at which the sound is played. A pitch of 2.0 means that the sound should be played twice as fast and one octave higher than normal.

SoSFTime SoVRMLAudioClip::startTime

| Specifies the start time. Default value is 0.

SoSFTime SoVRMLAudioClip::stopTime

| Specifies the stop time. Default value is 0.

SoMFString SoVRMLAudioClip::url

| The audio data URL.

SoVRMLAudioClip::duration_changed`[protected]`

| An eventOut sent when a new sound starts playing.

SoVRMLAudioClip::isActive`[protected]`

| This eventOut is sent when the sound starts/stops playing.

The documentation for this class was generated from the following files:

- SoVRMLAudioClip.h
- AudioClip.cpp